/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef MMBOX_OSDINPUT_HPP
#define MMBOX_OSDINPUT_HPP MMBOX_OSDINPUT_HPP

#include "../../main/mmboxstate.hpp"

// include used interfaces
#include "nmm/interfaces/video/osd/manager/IOSDManager.hpp"

namespace NMM {

  class OSDInputState : public MMBoxState {
  public:
    OSDInputState( string,  MMBoxApplication* );
    ~OSDInputState();
  
    Result doCreate( string );
    Result doKill();
  
    Result Up();
    Result Down();
    Result Left();
    Result Right();
  
    Result Back();
    Result Return();
  
  private:
    IOSDManager* manager;
  };

}

#endif //MMBOX_OSDINPUT_HPP
