
#ifndef NMM_IFileMetaInformation_HPP
#define NMM_IFileMetaInformation_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IFileMetaInformation : virtual public Interface { 
  public:
    IFileMetaInformation() {  setTypeInfo(TypeInfo(IFileMetaInformation::IFileMetaInformation_type, "NMM")); };

    IFileMetaInformation(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IFileMetaInformation::IFileMetaInformation_type, "NMM")); setEventReceiver(parent); };

    virtual ~IFileMetaInformation() {};

    static const char* IFileMetaInformation_type;

    virtual  string getInterfaceType() const { return IFileMetaInformation_type; }

    Interface* copy() const { return new IFileMetaInformation(*this); }
    static const char* fillMetaInformation_event;
    static const char* getAccessTime_event;
    static const char* getNumAccessTime_event;
    static const char* getModifyTime_event;
    static const char* getNumModifyTime_event;
    static const char* getCreationTime_event;
    static const char* getNumCreationTime_event;
    static const char* getTitle_event;
    static const char* getAlbum_event;
    static const char* getArtist_event;
    static const char* getGenre_event;
    static const char* getDate_event;
    static const char* getMimeType_event;
    static const char* getAudioFormat_event;
    static const char* getVideoFormat_event;
    static const char* getMode_event;
    static const char* getIsDir_event;

    virtual bool fillMetaInformation(const string& name)
      throw(const Exception&);

    virtual string getAccessTime()
      throw(const Exception&);

    virtual long getNumAccessTime()
      throw(const Exception&);

    virtual string getModifyTime()
      throw(const Exception&);

    virtual long getNumModifyTime()
      throw(const Exception&);

    virtual string getCreationTime()
      throw(const Exception&);

    virtual long getNumCreationTime()
      throw(const Exception&);

    virtual string getTitle()
      throw(const Exception&);

    virtual string getAlbum()
      throw(const Exception&);

    virtual string getArtist()
      throw(const Exception&);

    virtual string getGenre()
      throw(const Exception&);

    virtual string getDate()
      throw(const Exception&);

    virtual string getMimeType()
      throw(const Exception&);

    virtual string getAudioFormat()
      throw(const Exception&);

    virtual string getVideoFormat()
      throw(const Exception&);
// This funciton returns the st_mode value
// return by stat()

    virtual int getMode()
      throw(const Exception&);

    virtual bool getIsDir()
      throw(const Exception&);


  };

  typedef auto_ptr<IFileMetaInformation> IFileMetaInformation_var;




}

#endif
