
#ifndef NMM_IFileMetaInformationImpl_HPP
#define NMM_IFileMetaInformationImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IFileMetaInformation.hpp"


namespace NMM
{

  class IFileMetaInformationImpl  : public virtual NMMObject { 
  public:
    IFileMetaInformationImpl() { addInterface(new IFileMetaInformation(*this)); registerEvents(); };

    virtual ~IFileMetaInformationImpl() {};

  protected:

    virtual bool fillMetaInformation(const string& name) = 0;

    virtual string getAccessTime() = 0;

    virtual long getNumAccessTime() = 0;

    virtual string getModifyTime() = 0;

    virtual long getNumModifyTime() = 0;

    virtual string getCreationTime() = 0;

    virtual long getNumCreationTime() = 0;

    virtual string getTitle() = 0;

    virtual string getAlbum() = 0;

    virtual string getArtist() = 0;

    virtual string getGenre() = 0;

    virtual string getDate() = 0;

    virtual string getMimeType() = 0;

    virtual string getAudioFormat() = 0;

    virtual string getVideoFormat() = 0;
// This funciton returns the st_mode value
// return by stat()

    virtual int getMode() = 0;

    virtual bool getIsDir() = 0;


  private:
    void registerEvents();
  };

}

#endif
