
#ifndef NMM_INavFileImpl_HPP
#define NMM_INavFileImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "INavFile.hpp"


namespace NMM
{

  class INavFileImpl  : public virtual NMMObject { 
  public:
    INavFileImpl() { addInterface(new INavFile(*this)); registerEvents(); };

    virtual ~INavFileImpl() {};

  protected:
    /** Return the first level directory childs of dir.
	The string return is a coma ',' separate list of directory name.
        @param dir directory to scan. */

    virtual list<string >  getDirectoryList(const string& dir) = 0;
    /** Return the name of files contained at dir.
	The string return is a coma ',' separate list of files.
	@param dir directory to scan. */

    virtual list<string >  getFileList(const string& dir) = 0;


  private:
    void registerEvents();
  };

}

#endif
