/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        NMM work group,
 *                    http://www.networkmultimedia.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#define DEBUG 0

//#include <errno.h>
#include <unistd.h>
//#include <stdarg.h>
//#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <lirc/lirc_client.h>

#include <iostream>
#include <string>

char *progname;

using namespace std;

int main(int argc, char *argv[])
{
  struct lirc_config *config;
  
  progname=argv[0];
  if(argc>2) {
    cerr << "Usage: " << progname << " <config file>" << endl;
    exit(EXIT_FAILURE);
  }

  string appname = "nmmlirc";
  
  if(lirc_init((char *)appname.c_str(),1)==-1) {
    cerr << endl;
    cerr << "Could not initialize lirc!" << endl;
    cerr << "Make sure lircd is started, lirc-modules are loaded" << endl;
    cerr << "and ir-hardware is connected!" << endl;
    exit(EXIT_FAILURE);
  }

  if(lirc_readconfig(argc==2 ? argv[1]:NULL,&config,NULL)==0) {
    char *code;
    char *c;
    int ret;
    
    while(lirc_nextcode(&code)==0) {
      if(code==NULL) continue;
      while((ret=lirc_code2char(config,code,&c))==0 && c!=NULL) {
	if (DEBUG) cout << "Parsing command "<< c << endl;
	if (!strcmp(c,"POWER_VCR")) cout << "Pressed Power!" << endl;
	if (!strcmp(c,"PLAY"))      cout << "Pressed Play!" << endl;
	if (!strcmp(c,"PAUSE"))     cout << "Pressed Pause!" << endl;
	if (!strcmp(c,"STOP"))      cout << "Pressed Stop!" << endl;
	if (!strcmp(c,"FORWARD"))   cout << "Pressed Forward!" << endl;
	if (!strcmp(c,"REWIND"))    cout << "Pressed Rewind!" << endl;
      }
      free(code);
      if(ret==-1) break;
    }
    lirc_freeconfig(config);
  }
  else cout << "lirc_readconfig failed" << endl;
  
  lirc_deinit();
  exit(EXIT_SUCCESS);
}
