/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef NMM_IRECEIVER_HPP
#define NMM_IRECEIVER_HPP

#include "nmm/NMMTypes.hpp"

namespace NMM {
class IMessageSender;
class CEvent;
class Event;
class Message;
class IEventSender;

class IEventReceiver {
public:

  virtual Result receiveEvent(const CEvent&, const IEventSender* = 0 ) = 0;
  virtual Result receiveEvent(const Event&, const IEventSender* = 0 )  = 0;

  virtual Result receiveEvent(const CEvent&, const IEventSender* = 0 ) const = 0;
  virtual Result receiveEvent(const Event&, const IEventSender* = 0 )  const = 0;

  virtual Event* getEventPrototype(const string&)  const   {return 0;}
};


class IMessageReceiver  {
public:
  virtual Result receiveMessage(Message* , const IMessageSender* ) = 0;
};
}
#endif


