/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef NMM_ISENDER_HPP
#define NMM_ISENDER_HPP
#include "nmm/NMMTypes.hpp"


namespace NMM {
class Message;
class CEvent;
class Event;
class IEventReceiver;

class IEventSender  {
public:
  virtual Result sendEvent( const CEvent& ce)           = 0;
  virtual Result sendEvent( const Event& e)             = 0;

  virtual Result sendEvent( const CEvent& ce)   const   = 0;
  virtual Result sendEvent( const Event& e)     const   = 0;
};


class IMessageSender  {
public:
  virtual Result sendMessage(Message*) = 0;
};
}
#endif


