/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Marco Lohse <mlohse@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#include "Jack.hpp"
#include "Node.hpp"
#include "GenericNode.hpp"

namespace NMM {

  Jack::Jack(Node* parent, const string& jack_tag /*= "default"*/, const string& name /*= "Jack"*/)
    : StdNamedObject(name),__parent(parent), __jack_tag(jack_tag), __partner(0), __message_receiver(0) { 
    __signal_receiver = dynamic_cast<ISignalReceiver*>(parent);
  }

Node* Jack::getParent()                        {return __parent; }
const Node* Jack::getParent()      const       {return __parent; }

INode* Jack::getIParent()                      {return __parent->getInterface<INode>(); }
//const INode* Jack::getIParent()    const       {return __parent->getInterface<INode>(); }


}
