
#include "ITagInfo.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ITagInfo::TagInfo(const string& title, const string& album, const string& artist, const string& year, const string& genre) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > title_value(title, false);
    TInValue<string > album_value(album, false);
    TInValue<string > artist_value(artist, false);
    TInValue<string > year_value(year, false);
    TInValue<string > genre_value(genre, false);
    Event event("ITagInfo::TagInfo", &title_value, &album_value, &artist_value, &year_value, &genre_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ITagInfo::ITagInfo_type = "ITagInfo";
  TIFactoryObject<ITagInfo > __ITagInfo_prototype("ITagInfo");


  const char* ITagInfo::TagInfo_event = "ITagInfo::TagInfo";
  Event* ITagInfo::create_TagInfo(const string& title, const string& album, const string& artist, const string& year, const string& genre)
  {
    TInValue<string >* title_value = new TInValue<string >();
    title_value->setValue(title);
    TInValue<string >* album_value = new TInValue<string >();
    album_value->setValue(album);
    TInValue<string >* artist_value = new TInValue<string >();
    artist_value->setValue(artist);
    TInValue<string >* year_value = new TInValue<string >();
    year_value->setValue(year);
    TInValue<string >* genre_value = new TInValue<string >();
    genre_value->setValue(genre);

    return new Event("ITagInfo::TagInfo", title_value, album_value, artist_value, year_value, genre_value);
  }



}


