
#ifndef NMM_ITagInfo_HPP
#define NMM_ITagInfo_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ITagInfo : virtual public Interface { 
  public:
    ITagInfo() {  setTypeInfo(TypeInfo(ITagInfo::ITagInfo_type, "NMM")); };

    ITagInfo(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ITagInfo::ITagInfo_type, "NMM")); setEventReceiver(parent); };

    virtual ~ITagInfo() {};

    static const char* ITagInfo_type;

    virtual  string getInterfaceType() const { return ITagInfo_type; }

    Interface* copy() const { return new ITagInfo(*this); }
    static const char* TagInfo_event;
    static Event* create_TagInfo(const string& title, const string& album, const string& artist, const string& year, const string& genre);
  /* instream (protected) and non-instream (public) */    
    virtual Result TagInfo(const string& title, const string& album, const string& artist, const string& year, const string& genre) /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ITagInfo> ITagInfo_var;




}

#endif
