
#ifndef NMM_ILADSPAImpl_HPP
#define NMM_ILADSPAImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ILADSPA.hpp"


namespace NMM
{

  class ILADSPAImpl  : public virtual NMMObject { 
  public:
    ILADSPAImpl() { addInterface(new ILADSPA(*this)); registerEvents(); };

    virtual ~ILADSPAImpl() {};

  protected:

    virtual bool addLADSPAPlugin(const string& value, string& name, unsigned int& execpos) = 0;

    virtual void removeLADSPAPluginByName(const string& name) = 0;

    virtual void removeLADSPAPluginByIndex(const unsigned int& index) = 0;

    virtual unsigned int getLADSPAPluginCount() = 0;

    virtual void setConfigFilename(const string& value) = 0;

    virtual void setConfigProfileByName(const string& name, const string& profile) = 0;

    virtual void setConfigProfileByIndex(const unsigned int& index, const string& profile) = 0;

    virtual void resetToBaseValuesByName(const string& name) = 0;

    virtual void resetToBaseValuesByIndex(const unsigned int& index) = 0;

    virtual void setControlInValueByName(const string& name, const unsigned int& port, const float& value) = 0;

    virtual void setControlInValueByIndex(const unsigned int& index, const unsigned int& port, const float& value) = 0;

    virtual float getControlInValueByName(const string& name, const unsigned int& port) = 0;

    virtual float getControlInValueByIndex(const unsigned int& index, const unsigned int& port) = 0;

    virtual string getControlInNameByName(const string& name, const unsigned int& port) = 0;

    virtual string getControlInNameByIndex(const unsigned int& index, const unsigned int& port) = 0;

    virtual void setControlInBaseByName(const string& name, const unsigned int& port, const float& value) = 0;

    virtual void setControlInBaseByIndex(const unsigned int& index, const unsigned int& port, const float& value) = 0;

    virtual float getControlInBaseByName(const string& name, const unsigned int& port) = 0;

    virtual float getControlInBaseByIndex(const unsigned int& index, const unsigned int& port) = 0;

    virtual unsigned int getLADSPAPluginIndex(const string& name) = 0;

    virtual string getLADSPAPluginName(const unsigned int& index) = 0;

    virtual unsigned int getControlInCountByName(const string& name) = 0;

    virtual unsigned int getControlInCountByIndex(const unsigned int& index) = 0;

    virtual bool hasControlInUpperBoundByName(const string& name, const unsigned int& port) = 0;

    virtual bool hasControlInUpperBoundByIndex(const unsigned int& index, const unsigned int& port) = 0;

    virtual bool hasControlInLowerBoundByName(const string& name, const unsigned int& port) = 0;

    virtual bool hasControlInLowerBoundByIndex(const unsigned int& index, const unsigned int& port) = 0;

    virtual void getControlInBoundsByName(const string& name, const unsigned int& port, float& lower, float& upper) = 0;

    virtual void getControlInBoundsByIndex(const unsigned int& index, const unsigned int& port, float& lower, float& upper) = 0;

    virtual string getLADSPAPluginRealNameByName(const string& name) = 0;

    virtual string getLADSPAPluginRealNameByIndex(const unsigned int& index) = 0;

    virtual string getLADSPAPluginLabelByName(const string& name) = 0;

    virtual string getLADSPAPluginLabelByIndex(const unsigned int& index) = 0;

    virtual string getLADSPAPluginLibraryNameByName(const string& name) = 0;

    virtual string getLADSPAPluginLibraryNameByIndex(const unsigned int& index) = 0;


  private:
    void registerEvents();
  };

}

#endif
