
#include "IScope.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IScope::setBlurEnabled(const bool& toggle)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<bool > toggle_value(toggle, false);
    Event event("IScope::setBlurEnabled", &toggle_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IScope::setBlurStep(const int& value)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<int > value_value(value, false);
    Event event("IScope::setBlurStep", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IScope::IScope_type = "IScope";
  TIFactoryObject<IScope > __IScope_prototype("IScope");


  const char* IScope::setBlurEnabled_event = "IScope::setBlurEnabled";
  const char* IScope::setBlurStep_event = "IScope::setBlurStep";


}


