
#ifndef NMM_IScope_HPP
#define NMM_IScope_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IScope : virtual public Interface { 
  public:
    IScope() {  setTypeInfo(TypeInfo(IScope::IScope_type, "NMM")); };

    IScope(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IScope::IScope_type, "NMM")); setEventReceiver(parent); };

    virtual ~IScope() {};

    static const char* IScope_type;

    virtual  string getInterfaceType() const { return IScope_type; }

    Interface* copy() const { return new IScope(*this); }
    static const char* setBlurEnabled_event;
    static const char* setBlurStep_event;
    /**
     * this method enables or disables the blur effect.
     */

    virtual Result setBlurEnabled(const bool& toggle)
      throw(const Exception&);
    /**
     * sets the intensity of the blur effect.
     */

    virtual Result setBlurStep(const int& value)
      throw(const Exception&);


  };

  typedef auto_ptr<IScope> IScope_var;




}

#endif
