
#include "IAVMux.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IAVMux::setSyncMode(const bool& value)
      throw(const Exception&)
  {
    TInValue<bool > value_value(value, false);
    Event event("IAVMux::setSyncMode", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IAVMux::IAVMux_type = "IAVMux";
  TIFactoryObject<IAVMux > __IAVMux_prototype("IAVMux");
  TValueConstructor< IAVMux::Label > __IAVMux_Label_prototype(TypeInfo("IAVMux::Label", "NMM"));

  OValueStream& operator<<(OValueStream& ov, const IAVMux::Label& t)
  {
    ov.beginType(TypeInfo("IAVMux::Label", "NMM"));
    ov << reinterpret_cast<const int&>(t);
    ov.endType();
    return ov;
  }

  IValueStream& operator>>(IValueStream& iv, IAVMux::Label& t)
  {
    if(iv.getCurrentTypeInfo() != TypeInfo("IAVMux::Label", "NMM")) {
      throw InvalidTypeException(TypeInfo("IAVMux::Label", "NMM"), iv.getCurrentTypeInfo());
    }
    iv.goDown();
    iv >> reinterpret_cast<int&>(t);
    iv.goUp();
    return iv;
  }



  const char* IAVMux::setSyncMode_event = "IAVMux::setSyncMode";


}


