
#include "ISetBufferLabel.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ISetBufferLabel::setBufferLabel(const string& stream, const int& label) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > stream_value(stream, false);
    TInValue<int > label_value(label, false);
    Event event("ISetBufferLabel::setBufferLabel", &stream_value, &label_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISetBufferLabel::ISetBufferLabel_type = "ISetBufferLabel";
  TIFactoryObject<ISetBufferLabel > __ISetBufferLabel_prototype("ISetBufferLabel");


  const char* ISetBufferLabel::setBufferLabel_event = "ISetBufferLabel::setBufferLabel";
  Event* ISetBufferLabel::create_setBufferLabel(const string& stream, const int& label)
  {
    TInValue<string >* stream_value = new TInValue<string >();
    stream_value->setValue(stream);
    TInValue<int >* label_value = new TInValue<int >();
    label_value->setValue(label);

    return new Event("ISetBufferLabel::setBufferLabel", stream_value, label_value);
  }



}


