
#include "IMPEGDemux.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IMPEGDemux::setVideoStream(const int& stream)
      throw(const Exception&)
  {
    TInValue<int > stream_value(stream, false);
    Event event("IMPEGDemux::setVideoStream", &stream_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IMPEGDemux::setAudioStream(const int& stream)
      throw(const Exception&)
  {
    TInValue<int > stream_value(stream, false);
    Event event("IMPEGDemux::setAudioStream", &stream_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IMPEGDemux::setSPUStream(const int& stream)
      throw(const Exception&)
  {
    TInValue<int > stream_value(stream, false);
    Event event("IMPEGDemux::setSPUStream", &stream_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IMPEGDemux::setDVDMode(const bool& stream)
      throw(const Exception&)
  {
    TInValue<bool > stream_value(stream, false);
    Event event("IMPEGDemux::setDVDMode", &stream_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IMPEGDemux::IMPEGDemux_type = "IMPEGDemux";
  TIFactoryObject<IMPEGDemux > __IMPEGDemux_prototype("IMPEGDemux");


  const char* IMPEGDemux::setVideoStream_event = "IMPEGDemux::setVideoStream";
  const char* IMPEGDemux::setAudioStream_event = "IMPEGDemux::setAudioStream";
  const char* IMPEGDemux::setSPUStream_event = "IMPEGDemux::setSPUStream";
  const char* IMPEGDemux::setDVDMode_event = "IMPEGDemux::setDVDMode";


}


