
#ifndef NMM_IInputJackImpl_HPP
#define NMM_IInputJackImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IInputJack.hpp"

#include "IJackImpl.hpp"
#include "ITransportStrategyImpl.hpp"

namespace NMM
{

  class IInputJackImpl  : virtual public IJackImpl { 
  public:
    IInputJackImpl() { addInterface(new IInputJack(*this)); registerEvents(); };

    virtual ~IInputJackImpl() {};

  protected:
    /**
     * Connect to a partner jack.
     * \param jack partner jack.
     */

    virtual CommunicationChannel* connectTo(const IOutputJack& jack) 
      throw(const BindingException&) = 0;
    /**
     * A method to obtain a pointer to the data partner of this jack.
     * \returns a copy to the data partner jack of this jack, or NULL
     * if this jack has no data partner.
     */

    virtual IOutputJack* getDataPartner() = 0;

    virtual ITransportStrategy* getTransportStrategy() = 0;


  private:
    void registerEvents();
  };

}

#endif
