
#ifndef NMM_IInstream_HPP
#define NMM_IInstream_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IInstream : virtual public Interface { 
  public:
    IInstream() {  setTypeInfo(TypeInfo(IInstream::IInstream_type, "NMM")); };

    IInstream(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IInstream::IInstream_type, "NMM")); setEventReceiver(parent); };

    virtual ~IInstream() {};

    static const char* IInstream_type;

    virtual  string getInterfaceType() const { return IInstream_type; }

    Interface* copy() const { return new IInstream(*this); }
    static const char* sendMessageUpstream_event;
    static const char* sendMessageDownstream_event;

    virtual Result sendMessageUpstream(const CEvent& cevent)
      throw(const Exception&);

    virtual Result sendMessageDownstream(const CEvent& cevent)
      throw(const Exception&);


  };

  typedef auto_ptr<IInstream> IInstream_var;




}

#endif
