
#ifndef NMM_IOutputJackImpl_HPP
#define NMM_IOutputJackImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IOutputJack.hpp"

#include "IJackImpl.hpp"
#include "ITransportStrategyImpl.hpp"

namespace NMM
{

  class IOutputJackImpl  : virtual public IJackImpl { 
  public:
    IOutputJackImpl() { addInterface(new IOutputJack(*this)); registerEvents(); };

    virtual ~IOutputJackImpl() {};

  protected:
    /**
     * Connect to a partner jack.
     * \param jack partner jack.
     */

    virtual CommunicationChannel* connectTo(const IInputJack& jack) 
      throw(const BindingException&) = 0;
    /**
     * A method to obtain a pointer to the data partner of this jack.
     * \returns a copy to the data partner jack of this jack, or NULL
     * if this jack has no data partner.
     */

    virtual IInputJack* getDataPartner() = 0;

    virtual ITransportStrategy* getTransportStrategy() = 0;


  private:
    void registerEvents();
  };

}

#endif
