
#ifndef NMM_IThreadedNodeImpl_HPP
#define NMM_IThreadedNodeImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IThreadedNode.hpp"

#include "INodeImpl.hpp"

namespace NMM
{

  class IThreadedNodeImpl  : public virtual NMMObject { 
  public:
    IThreadedNodeImpl() { addInterface(new IThreadedNode(*this)); registerEvents(); };

    virtual ~IThreadedNodeImpl() {};

  protected:
    /**
     * Lower the thread priority by amount. The value must be between 1-20.
     */

    virtual void lowerPriority(const unsigned int& value) /* limited(INode::OUTPUT_INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ = 0;


  private:
    void registerEvents();
  };

}

#endif
