
#include "IUsageNotify.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IUsageNotify::becomeMaster()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IUsageNotify::becomeMaster");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IUsageNotify::becomeSlave()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IUsageNotify::becomeSlave");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IUsageNotify::IUsageNotify_type = "IUsageNotify";
  TIFactoryObject<IUsageNotify > __IUsageNotify_prototype("IUsageNotify");


  const char* IUsageNotify::becomeMaster_event = "IUsageNotify::becomeMaster";
  const char* IUsageNotify::becomeSlave_event = "IUsageNotify::becomeSlave";


}


