
#include "IResourceManagerImpl.hpp"


namespace NMM
{
  
  void IResourceManagerImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(IResourceManager::setNetworkInterfaces_event, new TEDObject1<IResourceManagerImpl, unsigned int, void(IResourceManagerImpl:: * )(const unsigned int&), void >(this, &IResourceManagerImpl::setNetworkInterfaces));
  
    getEventDispatcher().registerEvent(IResourceManager::addNode_event, new TEDObject3<IResourceManagerImpl, INode*, unsigned int, unsigned int, Result(IResourceManagerImpl:: * )(const INode*, unsigned int&, const unsigned int&), Result >(this, &IResourceManagerImpl::addNode));
  
    getEventDispatcher().registerEvent(IResourceManager::releaseNode_event, new TEDObject2<IResourceManagerImpl, INode*, unsigned int, Result(IResourceManagerImpl:: * )(const INode*, const unsigned int&), Result >(this, &IResourceManagerImpl::releaseNode));
  
    getEventDispatcher().registerEvent(IResourceManager::getCPUInfo_event, new TEDObject4<IResourceManagerImpl, string, uint, uint, float, void(IResourceManagerImpl:: * )(string&, uint&, uint&, float&), void >(this, &IResourceManagerImpl::getCPUInfo));
  
    getEventDispatcher().registerEvent(IResourceManager::getCPUSpeed_event, new TEDObject2<IResourceManagerImpl, uint, float, void(IResourceManagerImpl:: * )(uint&, float&), void >(this, &IResourceManagerImpl::getCPUSpeed));
  
    getEventDispatcher().registerEvent(IResourceManager::getCPUFree_event, new TEDObject1<IResourceManagerImpl, float, void(IResourceManagerImpl:: * )(float&), void >(this, &IResourceManagerImpl::getCPUFree));
  
    getEventDispatcher().registerEvent(IResourceManager::setCPUUpdateIntervall_event, new TEDObject1<IResourceManagerImpl, unsigned int, void(IResourceManagerImpl:: * )(const unsigned int&), void >(this, &IResourceManagerImpl::setCPUUpdateIntervall));
  
    getEventDispatcher().registerEvent(IResourceManager::getCPULeft_event, new TEDObject1<IResourceManagerImpl, float, void(IResourceManagerImpl:: * )(float&), void >(this, &IResourceManagerImpl::getCPULeft));
  
    getEventDispatcher().registerEvent(IResourceManager::setReservationPending_event, new TEDObject0<IResourceManagerImpl, void(IResourceManagerImpl:: * )(), void >(this, &IResourceManagerImpl::setReservationPending));
  
    getEventDispatcher().registerEvent(IResourceManager::commitReservation_event, new TEDObject0<IResourceManagerImpl, void(IResourceManagerImpl:: * )(), void >(this, &IResourceManagerImpl::commitReservation));
  
    getEventDispatcher().registerEvent(IResourceManager::startServer_event, new TEDObject0<IResourceManagerImpl, void(IResourceManagerImpl:: * )(), void >(this, &IResourceManagerImpl::startServer));
  
    getEventDispatcher().registerEvent(IResourceManager::stopServer_event, new TEDObject0<IResourceManagerImpl, void(IResourceManagerImpl:: * )(), void >(this, &IResourceManagerImpl::stopServer));
  
    getEventDispatcher().registerEvent(IResourceManager::testConnection_event, new TEDObject1<IResourceManagerImpl, string, float(IResourceManagerImpl:: * )(const string&), float >(this, &IResourceManagerImpl::testConnection));
  
    getEventDispatcher().registerEvent(IResourceManager::testConnections_event, new TEDObject2<IResourceManagerImpl, list<string > , list<float > , void(IResourceManagerImpl:: * )(const list<string > &, list<float > &), void >(this, &IResourceManagerImpl::testConnections));
  
    getEventDispatcher().registerEvent(IResourceManager::setHosts_event, new TEDObject1<IResourceManagerImpl, list<string > , Result(IResourceManagerImpl:: * )(const list<string > &), Result >(this, &IResourceManagerImpl::setHosts));
  
    getEventDispatcher().registerEvent(IResourceManager::getCPUDescription_event, new TEDObject1<IResourceManagerImpl, string, void(IResourceManagerImpl:: * )(string&), void >(this, &IResourceManagerImpl::getCPUDescription));
  
    getEventDispatcher().registerEvent(IResourceManager::updateNodeInfo_event, new TEDObject1<IResourceManagerImpl, INode*, Result(IResourceManagerImpl:: * )(const INode*), Result >(this, &IResourceManagerImpl::updateNodeInfo));

  }

}


