
#include "ISourceSynchronizer.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ISourceSynchronizer::setMasterSkew(const Interval& skew)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<Interval > skew_value(skew, false);
    Event event("ISourceSynchronizer::setMasterSkew", &skew_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISourceSynchronizer::ISourceSynchronizer_type = "ISourceSynchronizer";
  TIFactoryObject<ISourceSynchronizer > __ISourceSynchronizer_prototype("ISourceSynchronizer");


  const char* ISourceSynchronizer::setMasterSkew_event = "ISourceSynchronizer::setMasterSkew";


}


