
#ifndef NMM_ISourceSynchronizer_HPP
#define NMM_ISourceSynchronizer_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "ISynchronizer.hpp"
#include "ISourceController.hpp"

namespace NMM
{

  class ISourceSynchronizer : virtual public ISynchronizer { 
  public:
    ISourceSynchronizer() {  setTypeInfo(TypeInfo(ISourceSynchronizer::ISourceSynchronizer_type, "NMM")); };

    ISourceSynchronizer(NMMObject& parent) : ISynchronizer(parent) {  setTypeInfo(TypeInfo(ISourceSynchronizer::ISourceSynchronizer_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISourceSynchronizer() {};

    static const char* ISourceSynchronizer_type;

    virtual  string getInterfaceType() const { return ISourceSynchronizer_type; }

    Interface* copy() const { return new ISourceSynchronizer(*this); }
    static const char* setMasterSkew_event;
    /**
     * Sets a skew between audio and video output.
     * The video output is presented later as the audio output.
     */

    virtual Result setMasterSkew(const Interval& skew)
      throw(const Exception&);


  };

  typedef auto_ptr<ISourceSynchronizer> ISourceSynchronizer_var;




}

#endif
