
#ifndef NMM_ISwitchImpl_HPP
#define NMM_ISwitchImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ISwitch.hpp"


namespace NMM
{

  class ISwitchImpl  : public virtual NMMObject { 
  public:
    ISwitchImpl() { addInterface(new ISwitch(*this)); registerEvents(); };

    virtual ~ISwitchImpl() {};

  protected:
    /**
     * Perform whatever switch operation is available
     */

    virtual void switchOutputs() = 0;
    /**
     * Perform whatever flush operation is available
     */

    virtual void flushOutputs(const Timestamp& ts) = 0;
    /**
     * Sets whether the outgoing streams should be checked
     * for new connections
     */

    virtual void setSwitchOutputsEnabled(const bool& enable) = 0;
    /**
     * Gets the status of the check for new connections
     */

    virtual bool getSwitchOutputsEnabled() = 0;


  private:
    void registerEvents();
  };

}

#endif
