
#include "ISyncReset.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ISyncReset::syncReset() /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ISyncReset::syncReset");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISyncReset::ISyncReset_type = "ISyncReset";
  TIFactoryObject<ISyncReset > __ISyncReset_prototype("ISyncReset");


  const char* ISyncReset::syncReset_event = "ISyncReset::syncReset";
  Event* ISyncReset::create_syncReset()
  {

    return new Event("ISyncReset::syncReset");
  }



}


