
#ifndef NMM_ISynchronizedImpl_HPP
#define NMM_ISynchronizedImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ISynchronized.hpp"

#include "ISyncResetImpl.hpp"

namespace NMM
{

  class ISynchronizedImpl  : virtual public ISyncResetImpl { 
  public:
    ISynchronizedImpl() { addInterface(new ISynchronized(*this)); registerEvents(); };

    virtual ~ISynchronizedImpl() {};

  protected:
    /**
     * With this method synchronization of the sync element can be switched on and off.
     * \param toggle true  if the object should be synchronized
     *               false if the object simply presents the buffers as
     *                     fast as possible (default mode).
     */

    virtual Result setSynchronized(const bool& toggle) /* in-stream */  = 0;
    /**
     * Get the status of the object, synchronized, or not synchronized
     */

    virtual bool isSynchronized() = 0;


  private:
    void registerEvents();
  };

}

#endif
