
#ifndef NMM_ICDDA_HPP
#define NMM_ICDDA_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/device/IDevice.hpp"

namespace NMM
{

  class ICDDA : virtual public IDevice { 
  public:
    ICDDA() {  setTypeInfo(TypeInfo(ICDDA::ICDDA_type, "NMM")); };

    ICDDA(NMMObject& parent) : IDevice(parent) {  setTypeInfo(TypeInfo(ICDDA::ICDDA_type, "NMM")); setEventReceiver(parent); };

    virtual ~ICDDA() {};

    static const char* ICDDA_type;

    virtual  string getInterfaceType() const { return ICDDA_type; }

    Interface* copy() const { return new ICDDA(*this); }
    static const char* setTrack_event;
    static const char* getTrack_event;
    static const char* setRepeat_event;
    static const char* getRepeat_event;
    static const char* getTotalTracks_event;
    static const char* numberTracks_event;
    static const char* isFinished_event;
    static const char* setOneTrackOnly_event;
    static const char* getOneTrackOnly_event;

    virtual Result setTrack(const int& track)
      throw(const Exception&);

    virtual int getTrack()
      throw(const Exception&);

    virtual void setRepeat(const bool& repeat)
      throw(const Exception&);

    virtual bool getRepeat()
      throw(const Exception&);

    virtual int getTotalTracks()
      throw(const Exception&);

    virtual void numberTracks(const bool& number)
      throw(const Exception&);

    virtual bool isFinished()
      throw(const Exception&);

    virtual void setOneTrackOnly(const bool& enable)
      throw(const Exception&);

    virtual bool getOneTrackOnly()
      throw(const Exception&);


  };

  typedef auto_ptr<ICDDA> ICDDA_var;




}

#endif
