
#include "IBufferSize.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IBufferSize::setBufferSize(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("IBufferSize::setBufferSize", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  int IBufferSize::getBufferSize()
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IBufferSize::getBufferSize");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IBufferSize::IBufferSize_type = "IBufferSize";
  TIFactoryObject<IBufferSize > __IBufferSize_prototype("IBufferSize");


  const char* IBufferSize::setBufferSize_event = "IBufferSize::setBufferSize";
  const char* IBufferSize::getBufferSize_event = "IBufferSize::getBufferSize";


}


