
#include "IMultipleSourceFileHandler.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IMultipleSourceFileHandler::addFilename(const string& name) /* limited(INode::CONSTRUCTED) */ /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<string > name_value(name, false);
    Event event("IMultipleSourceFileHandler::addFilename", &name_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }

  const char* IMultipleSourceFileHandler::IMultipleSourceFileHandler_type = "IMultipleSourceFileHandler";
  TIFactoryObject<IMultipleSourceFileHandler > __IMultipleSourceFileHandler_prototype("IMultipleSourceFileHandler");


  const char* IMultipleSourceFileHandler::addFilename_event = "IMultipleSourceFileHandler::addFilename";


}


