
#ifndef NMM_ISendFilenameAndTimestampImpl_HPP
#define NMM_ISendFilenameAndTimestampImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ISendFilenameAndTimestamp.hpp"


namespace NMM
{
  /**
   * Sending of timestamps.
   *
   * Defines an event containing a filename and a timestamp that can
   * be sent by any node and caught by the application.
   */

  class ISendFilenameAndTimestampImpl  : public virtual NMMObject { 
  public:
    ISendFilenameAndTimestampImpl() { addInterface(new ISendFilenameAndTimestamp(*this)); registerEvents(); };

    virtual ~ISendFilenameAndTimestampImpl() {};

  protected:
    /**
     * Send the filename and timestamp
     * @param ts the timestamp to be sent
     */

    virtual Result sendFilenameAndTimestamp(const string& fn, const Timestamp& ts) /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
