
#include "ITrackDuration.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ITrackDuration::trackDuration(const Interval& i) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<Interval > i_value(i, false);
    Event event("ITrackDuration::trackDuration", &i_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ITrackDuration::ITrackDuration_type = "ITrackDuration";
  TIFactoryObject<ITrackDuration > __ITrackDuration_prototype("ITrackDuration");


  const char* ITrackDuration::trackDuration_event = "ITrackDuration::trackDuration";
  Event* ITrackDuration::create_trackDuration(const Interval& i)
  {
    TInValue<Interval >* i_value = new TInValue<Interval >();
    i_value->setValue(i);

    return new Event("ITrackDuration::trackDuration", i_value);
  }



}


