
#ifndef NMM_ITimeProgressListenerImpl_HPP
#define NMM_ITimeProgressListenerImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ITimeProgressListener.hpp"


namespace NMM
{
  /**
   *  @brief Progress events
   *
   *  Instream events for sending progress information.
   *  Nodes that implement the ITimeProgress interface send events of this interface.
   *  Applications that need progress information typically register listeners for these events.
   */

  class ITimeProgressListenerImpl  : public virtual NMMObject { 
  public:
    ITimeProgressListenerImpl() { addInterface(new ITimeProgressListener(*this)); registerEvents(); };

    virtual ~ITimeProgressListenerImpl() {};

  protected:
    /**
     *  @brief Progress information.
     *  @param Contains the current playback time.
     *
     *  Instream event containing the current time progress.
     */

    virtual void setTimeProgress(const Time& current_media_time) /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
