
#ifndef NMM_IDVBEPGPluginImpl_HPP
#define NMM_IDVBEPGPluginImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IDVBEPGPlugin.hpp"

#include "nmm/interfaces/video/tv/ITVCardImpl.hpp"
#include "nmm/interfaces/misc/tvmanager/ITVManagerImpl.hpp"

namespace NMM
{

  class IDVBEPGPluginImpl  : public virtual NMMObject { 
  public:
    IDVBEPGPluginImpl() { addInterface(new IDVBEPGPlugin(*this)); registerEvents(); };

    virtual ~IDVBEPGPluginImpl() {};

  protected:
    /**
     * Set the patch and name of the temporary config-file, where the plugin stores its current position in update
     *@param filepath and filename of configfile
     */

    virtual void setConfigFile(const string& f) = 0;
    /**
     * get the filename of the temp datafile
     *@return path + datafile
     */

    virtual string getConfigFile() = 0;
    /**
     *@param Application
     */ 

    virtual void setTVManager(const ITVManager* tvm) = 0;


  private:
    void registerEvents();
  };

}

#endif
