
#include "INxtvepgPlugin.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void INxtvepgPlugin::setLocation(const string& loc)
      throw(const Exception&)
  {
    TInValue<string > loc_value(loc, false);
    Event event("INxtvepgPlugin::setLocation", &loc_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void INxtvepgPlugin::setPort(const int& p)
      throw(const Exception&)
  {
    TInValue<int > p_value(p, false);
    Event event("INxtvepgPlugin::setPort", &p_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void INxtvepgPlugin::addProvider(const string& p)
      throw(const Exception&)
  {
    TInValue<string > p_value(p, false);
    Event event("INxtvepgPlugin::addProvider", &p_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  list<string >  INxtvepgPlugin::getProvider()
      throw(const Exception&)
  {
    TOutValue<list<string >  > return_value;
    Event event("INxtvepgPlugin::getProvider");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void INxtvepgPlugin::setConfigFile(const string& file)
      throw(const Exception&)
  {
    TInValue<string > file_value(file, false);
    Event event("INxtvepgPlugin::setConfigFile", &file_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string INxtvepgPlugin::getConfigFile()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("INxtvepgPlugin::getConfigFile");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void INxtvepgPlugin::setDBDir(const string& db)
      throw(const Exception&)
  {
    TInValue<string > db_value(db, false);
    Event event("INxtvepgPlugin::setDBDir", &db_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string INxtvepgPlugin::getDBDir()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("INxtvepgPlugin::getDBDir");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void INxtvepgPlugin::setLocale(const string& l)
      throw(const Exception&)
  {
    TInValue<string > l_value(l, false);
    Event event("INxtvepgPlugin::setLocale", &l_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string INxtvepgPlugin::getLocale()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("INxtvepgPlugin::getLocale");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void INxtvepgPlugin::setPeriod(const string& p)
      throw(const Exception&)
  {
    TInValue<string > p_value(p, false);
    Event event("INxtvepgPlugin::setPeriod", &p_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string INxtvepgPlugin::getPeriod()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("INxtvepgPlugin::getPeriod");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void INxtvepgPlugin::setUseTv_split(const bool& b)
      throw(const Exception&)
  {
    TInValue<bool > b_value(b, false);
    Event event("INxtvepgPlugin::setUseTv_split", &b_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  bool INxtvepgPlugin::getUseTv_split()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("INxtvepgPlugin::getUseTv_split");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* INxtvepgPlugin::INxtvepgPlugin_type = "INxtvepgPlugin";
  TIFactoryObject<INxtvepgPlugin > __INxtvepgPlugin_prototype("INxtvepgPlugin");


  const char* INxtvepgPlugin::setLocation_event = "INxtvepgPlugin::setLocation";
  const char* INxtvepgPlugin::setPort_event = "INxtvepgPlugin::setPort";
  const char* INxtvepgPlugin::addProvider_event = "INxtvepgPlugin::addProvider";
  const char* INxtvepgPlugin::getProvider_event = "INxtvepgPlugin::getProvider";
  const char* INxtvepgPlugin::setConfigFile_event = "INxtvepgPlugin::setConfigFile";
  const char* INxtvepgPlugin::getConfigFile_event = "INxtvepgPlugin::getConfigFile";
  const char* INxtvepgPlugin::setDBDir_event = "INxtvepgPlugin::setDBDir";
  const char* INxtvepgPlugin::getDBDir_event = "INxtvepgPlugin::getDBDir";
  const char* INxtvepgPlugin::setLocale_event = "INxtvepgPlugin::setLocale";
  const char* INxtvepgPlugin::getLocale_event = "INxtvepgPlugin::getLocale";
  const char* INxtvepgPlugin::setPeriod_event = "INxtvepgPlugin::setPeriod";
  const char* INxtvepgPlugin::getPeriod_event = "INxtvepgPlugin::getPeriod";
  const char* INxtvepgPlugin::setUseTv_split_event = "INxtvepgPlugin::setUseTv_split";
  const char* INxtvepgPlugin::getUseTv_split_event = "INxtvepgPlugin::getUseTv_split";


}


