
#include "ITVGuidePeerObject.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ITVGuidePeerObject::peerResult(const ProgramDescriptionList& pdlist, const int& id, const list<Interface* > & history)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<ProgramDescriptionList > pdlist_value(pdlist, false);
    TInValue<int > id_value(id, false);
    TInValue<list<Interface* >  > history_value(history, false);
    Event event("ITVGuidePeerObject::peerResult", &pdlist_value, &id_value, &history_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuidePeerObject::peerChannelResult(const ChannelDescriptionList& cdlist, const list<Interface* > & history)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<ChannelDescriptionList > cdlist_value(cdlist, false);
    TInValue<list<Interface* >  > history_value(history, false);
    Event event("ITVGuidePeerObject::peerChannelResult", &cdlist_value, &history_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ITVGuidePeerObject::ITVGuidePeerObject_type = "ITVGuidePeerObject";
  TIFactoryObject<ITVGuidePeerObject > __ITVGuidePeerObject_prototype("ITVGuidePeerObject");


  const char* ITVGuidePeerObject::peerResult_event = "ITVGuidePeerObject::peerResult";
  const char* ITVGuidePeerObject::peerChannelResult_event = "ITVGuidePeerObject::peerChannelResult";
  
  
  Result ITVGuidePeerSearch::peerSearch(const ProgramFilter& filter, const list<Interface* > & history)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<ProgramFilter > filter_value(filter, false);
    TInValue<list<Interface* >  > history_value(history, false);
    Event event("ITVGuidePeerSearch::peerSearch", &filter_value, &history_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuidePeerSearch::peerChannelSearch(const list<Interface* > & history)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<list<Interface* >  > history_value(history, false);
    Event event("ITVGuidePeerSearch::peerChannelSearch", &history_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ITVGuidePeerSearch::ITVGuidePeerSearch_type = "ITVGuidePeerSearch";
  TIFactoryObject<ITVGuidePeerSearch > __ITVGuidePeerSearch_prototype("ITVGuidePeerSearch");


  const char* ITVGuidePeerSearch::peerSearch_event = "ITVGuidePeerSearch::peerSearch";
  const char* ITVGuidePeerSearch::peerChannelSearch_event = "ITVGuidePeerSearch::peerChannelSearch";


}


