
#ifndef NMM_ITVGuideUpdateFinished_HPP
#define NMM_ITVGuideUpdateFinished_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   *This interface represents the events sent by a TVGuide-Plugin or the TVGuide itself*/

  class ITVGuideUpdateFinished : virtual public Interface { 
  public:
    ITVGuideUpdateFinished() {  setTypeInfo(TypeInfo(ITVGuideUpdateFinished::ITVGuideUpdateFinished_type, "NMM")); };

    ITVGuideUpdateFinished(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ITVGuideUpdateFinished::ITVGuideUpdateFinished_type, "NMM")); setEventReceiver(parent); };

    virtual ~ITVGuideUpdateFinished() {};

    static const char* ITVGuideUpdateFinished_type;

    virtual  string getInterfaceType() const { return ITVGuideUpdateFinished_type; }

    Interface* copy() const { return new ITVGuideUpdateFinished(*this); }
    static const char* partiallyFinished_event;
    static const char* finished_event;
    static const char* newChannel_event;
    static const char* newShow_event;
    static const char* informationUpdate_event;
    /**
     * Event sent when a certain state in grabbing data is reached
     */

    virtual Result partiallyFinished()
      throw(const Exception&);
    /*
     * This event is sent when all the data available is grabbed. Can only be sent by plugins wich are starteted periodically
     */

    virtual Result finished()
      throw(const Exception&);
    /**
     * Indicates, that a new channel is available in the database
     */

    virtual Result newChannel()
      throw(const Exception&);
    /**
     * indicates, that a new Event-Information is available for the given channel
     */

    virtual Result newShow(const string& channelID)
      throw(const Exception&);
    /**
     * Indicates, that the information for an already insertet event has been updated
     */

    virtual Result informationUpdate()
      throw(const Exception&);


  };

  typedef auto_ptr<ITVGuideUpdateFinished> ITVGuideUpdateFinished_var;




}

#endif
