
#include "IXMLTVPlugin.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IXMLTVPlugin::setFilename(const string& file)
      throw(const Exception&)
  {
    TInValue<string > file_value(file, false);
    Event event("IXMLTVPlugin::setFilename", &file_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string IXMLTVPlugin::getFilename()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IXMLTVPlugin::getFilename");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IXMLTVPlugin::setConfigFile(const string& file)
      throw(const Exception&)
  {
    TInValue<string > file_value(file, false);
    Event event("IXMLTVPlugin::setConfigFile", &file_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string IXMLTVPlugin::getConfigFile()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IXMLTVPlugin::getConfigFile");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IXMLTVPlugin::setLocale(const string& loc)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > loc_value(loc, false);
    Event event("IXMLTVPlugin::setLocale", &loc_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IXMLTVPlugin::getLocale()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IXMLTVPlugin::getLocale");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IXMLTVPlugin::setPeriod(const string& p)
      throw(const Exception&)
  {
    TInValue<string > p_value(p, false);
    Event event("IXMLTVPlugin::setPeriod", &p_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string IXMLTVPlugin::getPeriod()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IXMLTVPlugin::getPeriod");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IXMLTVPlugin::setFillHolesInDB(const bool& b)
      throw(const Exception&)
  {
    TInValue<bool > b_value(b, false);
    Event event("IXMLTVPlugin::setFillHolesInDB", &b_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  bool IXMLTVPlugin::getFillHolesInDB()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("IXMLTVPlugin::getFillHolesInDB");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IXMLTVPlugin::IXMLTVPlugin_type = "IXMLTVPlugin";
  TIFactoryObject<IXMLTVPlugin > __IXMLTVPlugin_prototype("IXMLTVPlugin");


  const char* IXMLTVPlugin::setFilename_event = "IXMLTVPlugin::setFilename";
  const char* IXMLTVPlugin::getFilename_event = "IXMLTVPlugin::getFilename";
  const char* IXMLTVPlugin::setConfigFile_event = "IXMLTVPlugin::setConfigFile";
  const char* IXMLTVPlugin::getConfigFile_event = "IXMLTVPlugin::getConfigFile";
  const char* IXMLTVPlugin::setLocale_event = "IXMLTVPlugin::setLocale";
  const char* IXMLTVPlugin::getLocale_event = "IXMLTVPlugin::getLocale";
  const char* IXMLTVPlugin::setPeriod_event = "IXMLTVPlugin::setPeriod";
  const char* IXMLTVPlugin::getPeriod_event = "IXMLTVPlugin::getPeriod";
  const char* IXMLTVPlugin::setFillHolesInDB_event = "IXMLTVPlugin::setFillHolesInDB";
  const char* IXMLTVPlugin::getFillHolesInDB_event = "IXMLTVPlugin::getFillHolesInDB";


}


