
#include "ITVTimerEvents.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ITVTimerEvents::recordingStopped(const unsigned int& id) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<unsigned int > id_value(id, false);
    Event event("ITVTimerEvents::recordingStopped", &id_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVTimerEvents::tvcardUnavailable(const unsigned int& id) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<unsigned int > id_value(id, false);
    Event event("ITVTimerEvents::tvcardUnavailable", &id_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVTimerEvents::timerUpdate() /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVTimerEvents::timerUpdate");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ITVTimerEvents::ITVTimerEvents_type = "ITVTimerEvents";
  TIFactoryObject<ITVTimerEvents > __ITVTimerEvents_prototype("ITVTimerEvents");


  const char* ITVTimerEvents::recordingStopped_event = "ITVTimerEvents::recordingStopped";
  Event* ITVTimerEvents::create_recordingStopped(const unsigned int& id)
  {
    TInValue<unsigned int >* id_value = new TInValue<unsigned int >();
    id_value->setValue(id);

    return new Event("ITVTimerEvents::recordingStopped", id_value);
  }

  const char* ITVTimerEvents::tvcardUnavailable_event = "ITVTimerEvents::tvcardUnavailable";
  Event* ITVTimerEvents::create_tvcardUnavailable(const unsigned int& id)
  {
    TInValue<unsigned int >* id_value = new TInValue<unsigned int >();
    id_value->setValue(id);

    return new Event("ITVTimerEvents::tvcardUnavailable", id_value);
  }

  const char* ITVTimerEvents::timerUpdate_event = "ITVTimerEvents::timerUpdate";
  Event* ITVTimerEvents::create_timerUpdate()
  {

    return new Event("ITVTimerEvents::timerUpdate");
  }



}


