
#include "IRTPParameters.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  string IRTPParameters::getRTPSinkMediaType() const
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IRTPParameters::getRTPSinkMediaType");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned char IRTPParameters::getRTPSinkPayloadType() const
      throw(const Exception&)
  {
    TOutValue<unsigned char > return_value;
    Event event("IRTPParameters::getRTPSinkPayloadType");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IRTPParameters::getRTPSinkMapLine() const
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IRTPParameters::getRTPSinkMapLine");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IRTPParameters::getRTPSinkAuxSDPLine() const
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IRTPParameters::getRTPSinkAuxSDPLine");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned short IRTPParameters::getRTPSeqNum() const
      throw(const Exception&)
  {
    TOutValue<unsigned short > return_value;
    Event event("IRTPParameters::getRTPSeqNum");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int IRTPParameters::getRTPTimestamp() const
      throw(const Exception&)
  {
    TOutValue<unsigned int > return_value;
    Event event("IRTPParameters::getRTPTimestamp");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int IRTPParameters::getRTPPort() const
      throw(const Exception&)
  {
    TOutValue<unsigned int > return_value;
    Event event("IRTPParameters::getRTPPort");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int IRTPParameters::getRTCPPort() const
      throw(const Exception&)
  {
    TOutValue<unsigned int > return_value;
    Event event("IRTPParameters::getRTCPPort");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IRTPParameters::IRTPParameters_type = "IRTPParameters";
  TIFactoryObject<IRTPParameters > __IRTPParameters_prototype("IRTPParameters");


  const char* IRTPParameters::getRTPSinkMediaType_event = "IRTPParameters::getRTPSinkMediaType";
  const char* IRTPParameters::getRTPSinkPayloadType_event = "IRTPParameters::getRTPSinkPayloadType";
  const char* IRTPParameters::getRTPSinkMapLine_event = "IRTPParameters::getRTPSinkMapLine";
  const char* IRTPParameters::getRTPSinkAuxSDPLine_event = "IRTPParameters::getRTPSinkAuxSDPLine";
  const char* IRTPParameters::getRTPSeqNum_event = "IRTPParameters::getRTPSeqNum";
  const char* IRTPParameters::getRTPTimestamp_event = "IRTPParameters::getRTPTimestamp";
  const char* IRTPParameters::getRTPPort_event = "IRTPParameters::getRTPPort";
  const char* IRTPParameters::getRTCPPort_event = "IRTPParameters::getRTCPPort";


}


