
#include "IURL.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IURL::setURL(const string& url)
      throw(const Exception&)
  {
    TInValue<string > url_value(url, false);
    Event event("IURL::setURL", &url_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string IURL::getURL() const
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IURL::getURL");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IURL::IURL_type = "IURL";
  TIFactoryObject<IURL > __IURL_prototype("IURL");


  const char* IURL::setURL_event = "IURL::setURL";
  const char* IURL::getURL_event = "IURL::getURL";


}


