
#include "IBuffersPassedEvent.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IBuffersPassedEventSender::setBufferCountInterval(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("IBuffersPassedEventSender::setBufferCountInterval", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  int IBuffersPassedEventSender::getBufferCountInterval() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IBuffersPassedEventSender::getBufferCountInterval");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IBuffersPassedEventSender::IBuffersPassedEventSender_type = "IBuffersPassedEventSender";
  TIFactoryObject<IBuffersPassedEventSender > __IBuffersPassedEventSender_prototype("IBuffersPassedEventSender");


  const char* IBuffersPassedEventSender::setBufferCountInterval_event = "IBuffersPassedEventSender::setBufferCountInterval";
  const char* IBuffersPassedEventSender::getBufferCountInterval_event = "IBuffersPassedEventSender::getBufferCountInterval";
  
  
  Result IBuffersPassedEventReceiver::buffersPassed(const int& buffers) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<int > buffers_value(buffers, false);
    Event event("IBuffersPassedEventReceiver::buffersPassed", &buffers_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int IBuffersPassedEventReceiver::getUpstreamBuffersPassed() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IBuffersPassedEventReceiver::getUpstreamBuffersPassed");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IBuffersPassedEventReceiver::resetUpstreamBufferCounter()
      throw(const Exception&)
  {
    Event event("IBuffersPassedEventReceiver::resetUpstreamBufferCounter");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IBuffersPassedEventReceiver::IBuffersPassedEventReceiver_type = "IBuffersPassedEventReceiver";
  TIFactoryObject<IBuffersPassedEventReceiver > __IBuffersPassedEventReceiver_prototype("IBuffersPassedEventReceiver");


  const char* IBuffersPassedEventReceiver::buffersPassed_event = "IBuffersPassedEventReceiver::buffersPassed";
  Event* IBuffersPassedEventReceiver::create_buffersPassed(const int& buffers)
  {
    TInValue<int >* buffers_value = new TInValue<int >();
    buffers_value->setValue(buffers);

    return new Event("IBuffersPassedEventReceiver::buffersPassed", buffers_value);
  }

  const char* IBuffersPassedEventReceiver::getUpstreamBuffersPassed_event = "IBuffersPassedEventReceiver::getUpstreamBuffersPassed";
  const char* IBuffersPassedEventReceiver::resetUpstreamBufferCounter_event = "IBuffersPassedEventReceiver::resetUpstreamBufferCounter";


}


