
#ifndef NMM_IFrameCountImpl_HPP
#define NMM_IFrameCountImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IFrameCount.hpp"


namespace NMM
{
  /**
   * Requesting of frame count.
   *
   * Defines a method that returns the frame count of some video stream.
   */

  class IFrameCountImpl  : public virtual NMMObject { 
  public:
    IFrameCountImpl() { addInterface(new IFrameCount(*this)); registerEvents(); };

    virtual ~IFrameCountImpl() {};

  protected:
    /**
     * Get the framecount
     */

    virtual int getFrameCount() const = 0;


  private:
    void registerEvents();
  };

}

#endif
