
#ifndef NMM_IFrameEncodeMode_HPP
#define NMM_IFrameEncodeMode_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IFrameEncodeMode : virtual public Interface { 
  public:
  enum Mode { 
    INTER_FRAME = 0 , 
    INTRA_FRAME = 1  };

    IFrameEncodeMode() {  setTypeInfo(TypeInfo(IFrameEncodeMode::IFrameEncodeMode_type, "NMM")); };

    IFrameEncodeMode(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IFrameEncodeMode::IFrameEncodeMode_type, "NMM")); setEventReceiver(parent); };

    virtual ~IFrameEncodeMode() {};

    static const char* IFrameEncodeMode_type;

    virtual  string getInterfaceType() const { return IFrameEncodeMode_type; }

    Interface* copy() const { return new IFrameEncodeMode(*this); }
    static const char* setFrameEncodeMode_event;
    static const char* getFrameEncodeMode_event;

    virtual void setFrameEncodeMode(const IFrameEncodeMode::Mode& value)
      throw(const Exception&);

    virtual IFrameEncodeMode::Mode getFrameEncodeMode() const
      throw(const Exception&);


  };

  typedef auto_ptr<IFrameEncodeMode> IFrameEncodeMode_var;

  OValueStream& operator<<(OValueStream& ov, const IFrameEncodeMode::Mode& t);
  IValueStream& operator>>(IValueStream& iv, IFrameEncodeMode::Mode& t);



}

#endif
