
#include "IMouseCursor.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IMouseCursor::useDotCursor(const bool& value)
      throw(const Exception&)
  {
    TInValue<bool > value_value(value, false);
    Event event("IMouseCursor::useDotCursor", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IMouseCursor::useStandardCursor()
      throw(const Exception&)
  {
    Event event("IMouseCursor::useStandardCursor");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IMouseCursor::useTriangleCursor(const bool& value)
      throw(const Exception&)
  {
    TInValue<bool > value_value(value, false);
    Event event("IMouseCursor::useTriangleCursor", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IMouseCursor::IMouseCursor_type = "IMouseCursor";
  TIFactoryObject<IMouseCursor > __IMouseCursor_prototype("IMouseCursor");


  const char* IMouseCursor::useDotCursor_event = "IMouseCursor::useDotCursor";
  const char* IMouseCursor::useStandardCursor_event = "IMouseCursor::useStandardCursor";
  const char* IMouseCursor::useTriangleCursor_event = "IMouseCursor::useTriangleCursor";


}


