
#ifndef NMM_IMouseCursorImpl_HPP
#define NMM_IMouseCursorImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IMouseCursor.hpp"


namespace NMM
{
  /**
   * Interface for setting mouse cursor properties.
   */

  class IMouseCursorImpl  : public virtual NMMObject { 
  public:
    IMouseCursorImpl() { addInterface(new IMouseCursor(*this)); registerEvents(); };

    virtual ~IMouseCursorImpl() {};

  protected:
    /**
     * Set dot mouse cursor in window.
     * @param value true for dot mouse cursor, false for standard mouse cursor
     */

    virtual void useDotCursor(const bool& value) = 0;
    /**
     * Use standard X mouse cursor in window.
     */

    virtual void useStandardCursor() = 0;
    /**
     * Set cursor to pixmap specified in src with mask msk.
     * @param src the cursor is set to this pixmap values
     * @param msk the mask for the cursor
     */

    virtual void useTriangleCursor(const bool& value) = 0;


  private:
    void registerEvents();
  };

}

#endif
