
#include "IBrightness.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IBrightness::setBrightness(const float& brightness)
      throw(const Exception&)
  {
    TInValue<float > brightness_value(brightness, false);
    Event event("IBrightness::setBrightness", &brightness_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IBrightness::IBrightness_type = "IBrightness";
  TIFactoryObject<IBrightness > __IBrightness_prototype("IBrightness");


  const char* IBrightness::setBrightness_event = "IBrightness::setBrightness";


}


