
#ifndef NMM_IOverlay_HPP
#define NMM_IOverlay_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "ISetOffset.hpp"

namespace NMM
{

  class IOverlay : virtual public ISetOffset { 
  public:
    IOverlay() {  setTypeInfo(TypeInfo(IOverlay::IOverlay_type, "NMM")); };

    IOverlay(NMMObject& parent) : ISetOffset(parent) {  setTypeInfo(TypeInfo(IOverlay::IOverlay_type, "NMM")); setEventReceiver(parent); };

    virtual ~IOverlay() {};

    static const char* IOverlay_type;

    virtual  string getInterfaceType() const { return IOverlay_type; }

    Interface* copy() const { return new IOverlay(*this); }
    static const char* setAlpha_event;
    static const char* getAlpha_event;
    static const char* setForeground_event;
    static const char* setForegroundSegment_event;
    static const char* disableOverlay_event;
    static Event* create_disableOverlay();

    virtual void setAlpha(const float& alpha)
      throw(const Exception&);

    virtual float getAlpha() const
      throw(const Exception&);
    /**
     * Set dimension and start coordinates of foreground image.
     * @param x x-position of upper left corner
     * @param y y-position of upper left corner
     * @param w width of foreground image
     * @param h height of foreground image
     */

    virtual void setForeground(const int& x, const int& y, const int& w, const int& h)
      throw(const Exception&);

    virtual void setForegroundSegment(const int& x, const int& y, const int& w, const int& h)
      throw(const Exception&);
  /* instream (protected) and non-instream (public) */    
    virtual Result disableOverlay() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<IOverlay> IOverlay_var;




}

#endif
