
#ifndef NMM_ISetOffset_HPP
#define NMM_ISetOffset_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ISetOffset : virtual public Interface { 
  public:
    ISetOffset() {  setTypeInfo(TypeInfo(ISetOffset::ISetOffset_type, "NMM")); };

    ISetOffset(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ISetOffset::ISetOffset_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISetOffset() {};

    static const char* ISetOffset_type;

    virtual  string getInterfaceType() const { return ISetOffset_type; }

    Interface* copy() const { return new ISetOffset(*this); }
    static const char* setOffset_event;
    static const char* getOffset_event;

    virtual void setOffset(const int& x, const int& y)
      throw(const Exception&);

    virtual void getOffset(int& x, int& y) const
      throw(const Exception&);


  };

  typedef auto_ptr<ISetOffset> ISetOffset_var;




}

#endif
