
#include "ICreateImage.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ICreateImage::createImage(const unsigned int& color, const unsigned int& w, const unsigned int& h)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<unsigned int > color_value(color, false);
    TInValue<unsigned int > w_value(w, false);
    TInValue<unsigned int > h_value(h, false);
    Event event("ICreateImage::createImage", &color_value, &w_value, &h_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ICreateImage::ICreateImage_type = "ICreateImage";
  TIFactoryObject<ICreateImage > __ICreateImage_prototype("ICreateImage");


  const char* ICreateImage::createImage_event = "ICreateImage::createImage";


}


