
#ifndef NMM_ICreateImage_HPP
#define NMM_ICreateImage_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ICreateImage : virtual public Interface { 
  public:
    ICreateImage() {  setTypeInfo(TypeInfo(ICreateImage::ICreateImage_type, "NMM")); };

    ICreateImage(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ICreateImage::ICreateImage_type, "NMM")); setEventReceiver(parent); };

    virtual ~ICreateImage() {};

    static const char* ICreateImage_type;

    virtual  string getInterfaceType() const { return ICreateImage_type; }

    Interface* copy() const { return new ICreateImage(*this); }
    static const char* createImage_event;

    virtual Result createImage(const unsigned int& color, const unsigned int& w, const unsigned int& h)
      throw(const Exception&);


  };

  typedef auto_ptr<ICreateImage> ICreateImage_var;




}

#endif
