
#ifndef NMM_IOSDSetFont_HPP
#define NMM_IOSDSetFont_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   * OSD base interface.
   * Base for all OSD interfaces that export a setFont method.
   */

  class IOSDSetFont : virtual public Interface { 
  public:
    IOSDSetFont() {  setTypeInfo(TypeInfo(IOSDSetFont::IOSDSetFont_type, "NMM")); };

    IOSDSetFont(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IOSDSetFont::IOSDSetFont_type, "NMM")); setEventReceiver(parent); };

    virtual ~IOSDSetFont() {};

    static const char* IOSDSetFont_type;

    virtual  string getInterfaceType() const { return IOSDSetFont_type; }

    Interface* copy() const { return new IOSDSetFont(*this); }
    static const char* setFont_event;
    /**
     * sets the Font of all text items
     * @param font_name path to locate the font
     * @param font_factor size of the font
     */

    virtual Result setFont(const string& font_name, const float& font_factor)
      throw(const Exception&);


  };

  typedef auto_ptr<IOSDSetFont> IOSDSetFont_var;




}

#endif
