
#ifndef NMM_IImageView_HPP
#define NMM_IImageView_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IWidget.hpp"

namespace NMM
{
  /**
   * Image view widget interface.
   */

  class IImageView : virtual public IWidget { 
  public:
    IImageView() {  setTypeInfo(TypeInfo(IImageView::IImageView_type, "NMM")); };

    IImageView(NMMObject& parent) : IWidget(parent) {  setTypeInfo(TypeInfo(IImageView::IImageView_type, "NMM")); setEventReceiver(parent); };

    virtual ~IImageView() {};

    static const char* IImageView_type;

    virtual  string getInterfaceType() const { return IImageView_type; }

    Interface* copy() const { return new IImageView(*this); }
    static const char* setBitmapID_event;
    /**
     * Set bitmap identifier.
     * Set identifier of bitmap that should be drawn.
     * @param id bitmap identifier
     */

    virtual void setBitmapID(const string& id)
      throw(const Exception&);


  };

  typedef auto_ptr<IImageView> IImageView_var;




}

#endif
