
#include "IOSDManagerImpl.hpp"


namespace NMM
{
  
  void IOSDManagerImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(IOSDManager::loadFont_event, new TEDObject3<IOSDManagerImpl, string, string, string, Result(IOSDManagerImpl:: * )(const string&, const string&, const string&), Result >(this, &IOSDManagerImpl::loadFont));
  
    getEventDispatcher().registerEvent(IOSDManager::getFontList_event, new TEDObject0<IOSDManagerImpl, list<string > (IOSDManagerImpl:: * )() const, list<string >  >(this, &IOSDManagerImpl::getFontList));
  
    getEventDispatcher().registerEvent(IOSDManager::update_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::update));
  
    getEventDispatcher().registerEvent(IOSDManager::getWidget_event, new TEDObject1<IOSDManagerImpl, int, IWidget*(IOSDManagerImpl:: * )(const int&), IWidget* >(this, &IOSDManagerImpl::getWidget));
  
    getEventDispatcher().registerEvent(IOSDManager::getWindow_event, new TEDObject1<IOSDManagerImpl, int, IWindow*(IOSDManagerImpl:: * )(const int&), IWindow* >(this, &IOSDManagerImpl::getWindow));
  
    getEventDispatcher().registerEvent(IOSDManager::createWindow_event, new TEDObject0<IOSDManagerImpl, IWindow*(IOSDManagerImpl:: * )(), IWindow* >(this, &IOSDManagerImpl::createWindow));
  
    getEventDispatcher().registerEvent(IOSDManager::deleteWindow_event, new TEDObject1<IOSDManagerImpl, IWindow, void(IOSDManagerImpl:: * )(const IWindow&), void >(this, &IOSDManagerImpl::deleteWindow));
  
    getEventDispatcher().registerEvent(IOSDManager::deleteWidget_event, new TEDObject1<IOSDManagerImpl, IWidget, void(IOSDManagerImpl:: * )(const IWidget&), void >(this, &IOSDManagerImpl::deleteWidget));
  
    getEventDispatcher().registerEvent(IOSDManager::displayMessage_event, new TEDObject6<IOSDManagerImpl, string, string, string, string, string, unsigned int, Result(IOSDManagerImpl:: * )(const string&, const string&, const string&, const string&, const string&, const unsigned int&), Result >(this, &IOSDManagerImpl::displayMessage));
  
    getEventDispatcher().registerEvent(IOSDManager::deleteMessage_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::deleteMessage));
  
    getEventDispatcher().registerEvent(IOSDManager::displayTime_event, new TEDObject3<IOSDManagerImpl, string, unsigned int, unsigned int, Result(IOSDManagerImpl:: * )(const string&, const unsigned int&, const unsigned int&), Result >(this, &IOSDManagerImpl::displayTime));
  
    getEventDispatcher().registerEvent(IOSDManager::createTime_event, new TEDObject1<IOSDManagerImpl, bool, Result(IOSDManagerImpl:: * )(const bool&), Result >(this, &IOSDManagerImpl::createTime));
  
    getEventDispatcher().registerEvent(IOSDManager::resetTime_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::resetTime));
  
    getEventDispatcher().registerEvent(IOSDManager::hideTime_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::hideTime));
  
    getEventDispatcher().registerEvent(IOSDManager::setTime_event, new TEDObject1<IOSDManagerImpl, u_int64_t, Result(IOSDManagerImpl:: * )(const u_int64_t&), Result >(this, &IOSDManagerImpl::setTime));
  
    getEventDispatcher().registerEvent(IOSDManager::getTime_event, new TEDObject0<IOSDManagerImpl, u_int64_t(IOSDManagerImpl:: * )(), u_int64_t >(this, &IOSDManagerImpl::getTime));
  
    getEventDispatcher().registerEvent(IOSDManager::displaySymbol_event, new TEDObject3<IOSDManagerImpl, string, unsigned int, unsigned int, Result(IOSDManagerImpl:: * )(const string&, const unsigned int&, const unsigned int&), Result >(this, &IOSDManagerImpl::displaySymbol));
  
    getEventDispatcher().registerEvent(IOSDManager::hideSymbol_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::hideSymbol));
  
    getEventDispatcher().registerEvent(IOSDManager::displayProgressBar_event, new TEDObject4<IOSDManagerImpl, string, unsigned int, unsigned int, unsigned int, Result(IOSDManagerImpl:: * )(const string&, const unsigned int&, const unsigned int&, const unsigned int&), Result >(this, &IOSDManagerImpl::displayProgressBar));
  
    getEventDispatcher().registerEvent(IOSDManager::hideProgressBar_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::hideProgressBar));
  
    getEventDispatcher().registerEvent(IOSDManager::setMaxProgress_event, new TEDObject1<IOSDManagerImpl, u_int64_t, void(IOSDManagerImpl:: * )(const u_int64_t&), void >(this, &IOSDManagerImpl::setMaxProgress));
  
    getEventDispatcher().registerEvent(IOSDManager::setProgress_event, new TEDObject1<IOSDManagerImpl, u_int64_t, void(IOSDManagerImpl:: * )(const u_int64_t&), void >(this, &IOSDManagerImpl::setProgress));
  
    getEventDispatcher().registerEvent(IOSDManager::updateProgress_event, new TEDObject0<IOSDManagerImpl, void(IOSDManagerImpl:: * )(), void >(this, &IOSDManagerImpl::updateProgress));
  
    getEventDispatcher().registerEvent(IOSDManager::displayColorBar_event, new TEDObject2<IOSDManagerImpl, unsigned int, unsigned int, Result(IOSDManagerImpl:: * )(const unsigned int&, const unsigned int&), Result >(this, &IOSDManagerImpl::displayColorBar));
  
    getEventDispatcher().registerEvent(IOSDManager::hideColorBar_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::hideColorBar));
  
    getEventDispatcher().registerEvent(IOSDManager::setColorBarText_event, new TEDObject4<IOSDManagerImpl, string, string, string, string, void(IOSDManagerImpl:: * )(const string&, const string&, const string&, const string&), void >(this, &IOSDManagerImpl::setColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::setRedColorBarText_event, new TEDObject1<IOSDManagerImpl, string, void(IOSDManagerImpl:: * )(const string&), void >(this, &IOSDManagerImpl::setRedColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::setGreenColorBarText_event, new TEDObject1<IOSDManagerImpl, string, void(IOSDManagerImpl:: * )(const string&), void >(this, &IOSDManagerImpl::setGreenColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::setYellowColorBarText_event, new TEDObject1<IOSDManagerImpl, string, void(IOSDManagerImpl:: * )(const string&), void >(this, &IOSDManagerImpl::setYellowColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::setBlueColorBarText_event, new TEDObject1<IOSDManagerImpl, string, void(IOSDManagerImpl:: * )(const string&), void >(this, &IOSDManagerImpl::setBlueColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::getRedColorBarText_event, new TEDObject0<IOSDManagerImpl, string(IOSDManagerImpl:: * )(), string >(this, &IOSDManagerImpl::getRedColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::getGreenColorBarText_event, new TEDObject0<IOSDManagerImpl, string(IOSDManagerImpl:: * )(), string >(this, &IOSDManagerImpl::getGreenColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::getYellowColorBarText_event, new TEDObject0<IOSDManagerImpl, string(IOSDManagerImpl:: * )(), string >(this, &IOSDManagerImpl::getYellowColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::getBlueColorBarText_event, new TEDObject0<IOSDManagerImpl, string(IOSDManagerImpl:: * )(), string >(this, &IOSDManagerImpl::getBlueColorBarText));
  
    getEventDispatcher().registerEvent(IOSDManager::messageLeft_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::messageLeft));
  
    getEventDispatcher().registerEvent(IOSDManager::messageRight_event, new TEDObject0<IOSDManagerImpl, Result(IOSDManagerImpl:: * )(), Result >(this, &IOSDManagerImpl::messageRight));
  
    getEventDispatcher().registerEvent(IOSDManager::messageID_event, new TEDObject0<IOSDManagerImpl, string(IOSDManagerImpl:: * )(), string >(this, &IOSDManagerImpl::messageID));
  
    getEventDispatcher().registerEvent(IOSDManager::setPause_event, new TEDObject1<IOSDManagerImpl, bool, void(IOSDManagerImpl:: * )(const bool&), void >(this, &IOSDManagerImpl::setPause));
  
    getEventDispatcher().registerEvent(IOSDManager::sendPauseEvent_event, new TEDObject0<IOSDManagerImpl, void(IOSDManagerImpl:: * )(), void >(this, &IOSDManagerImpl::sendPauseEvent));
  
    getEventDispatcher().registerEvent(IOSDManager::getBitmapReader_event, new TEDObject0<IOSDManagerImpl, IBitmapReader*(IOSDManagerImpl:: * )(), IBitmapReader* >(this, &IOSDManagerImpl::getBitmapReader));
  
    getEventDispatcher().registerEvent(IOSDManager::checkCharDimension_event, new TEDObject4<IOSDManagerImpl, string, unsigned char, unsigned int, unsigned int, void(IOSDManagerImpl:: * )(const string&, const unsigned char&, unsigned int&, unsigned int&) const, void >(this, &IOSDManagerImpl::checkCharDimension));
  
    getEventDispatcher().registerEvent(IOSDManager::getMaxWidth_event, new TEDObject1<IOSDManagerImpl, string, unsigned int(IOSDManagerImpl:: * )(const string&) const, unsigned int >(this, &IOSDManagerImpl::getMaxWidth));
  
    getEventDispatcher().registerEvent(IOSDManager::getMaxHeight_event, new TEDObject1<IOSDManagerImpl, string, unsigned int(IOSDManagerImpl:: * )(const string&) const, unsigned int >(this, &IOSDManagerImpl::getMaxHeight));
  
    getEventDispatcher().registerEvent(IOSDManager::setLineSpace_event, new TEDObject2<IOSDManagerImpl, string, unsigned int, void(IOSDManagerImpl:: * )(const string&, const unsigned int&), void >(this, &IOSDManagerImpl::setLineSpace));
  
    getEventDispatcher().registerEvent(IOSDManager::getLineSpace_event, new TEDObject1<IOSDManagerImpl, string, unsigned int(IOSDManagerImpl:: * )(const string&) const, unsigned int >(this, &IOSDManagerImpl::getLineSpace));

  }

}


