
#include "IPlaneDecorator.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IPlaneDecorator::setPlaneColor(const u_int32_t& color)
      throw(const Exception&)
  {
    TInValue<u_int32_t > color_value(color, false);
    Event event("IPlaneDecorator::setPlaneColor", &color_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IPlaneDecorator::IPlaneDecorator_type = "IPlaneDecorator";
  TIFactoryObject<IPlaneDecorator > __IPlaneDecorator_prototype("IPlaneDecorator");


  const char* IPlaneDecorator::setPlaneColor_event = "IPlaneDecorator::setPlaneColor";


}


