
#ifndef NMM_IRadioButtons_HPP
#define NMM_IRadioButtons_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IButtons.hpp"

namespace NMM
{
  /**
   * Radio buttons widget interface.
   * The activateButton methods work slightly different on this kind of widget.
   * If one button is activated, all other buttons are deactivated.
   */

  class IRadioButtons : virtual public IButtons { 
  public:
    IRadioButtons() {  setTypeInfo(TypeInfo(IRadioButtons::IRadioButtons_type, "NMM")); };

    IRadioButtons(NMMObject& parent) : IButtons(parent) {  setTypeInfo(TypeInfo(IRadioButtons::IRadioButtons_type, "NMM")); setEventReceiver(parent); };

    virtual ~IRadioButtons() {};

    static const char* IRadioButtons_type;

    virtual  string getInterfaceType() const { return IRadioButtons_type; }

    Interface* copy() const { return new IRadioButtons(*this); }


  };

  typedef auto_ptr<IRadioButtons> IRadioButtons_var;




}

#endif
