
#ifndef NMM_ISymbolChangeImpl_HPP
#define NMM_ISymbolChangeImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ISymbolChange.hpp"


namespace NMM
{
  /**
   * Symbol has changed.
   * Instream event, sent by the OSDManager when the symbol has been changed.
   * The event is sent after the first video frame that contains the new symbol.
   */

  class ISymbolChangeImpl  : public virtual NMMObject { 
  public:
    ISymbolChangeImpl() { addInterface(new ISymbolChange(*this)); registerEvents(); };

    virtual ~ISymbolChangeImpl() {};

  protected:

    virtual Result symbolChanged(const string& symbol) /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
