
#include "IDVBSimulator.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IDVBSimulator::setWorkingDirectory(const string& dir) /* limited(INode::CONSTRUCTED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<string > dir_value(dir, false);
    Event event("IDVBSimulator::setWorkingDirectory", &dir_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }

  const char* IDVBSimulator::IDVBSimulator_type = "IDVBSimulator";
  TIFactoryObject<IDVBSimulator > __IDVBSimulator_prototype("IDVBSimulator");


  const char* IDVBSimulator::setWorkingDirectory_event = "IDVBSimulator::setWorkingDirectory";


}


