
#ifndef NMM_IDVBSimulator_HPP
#define NMM_IDVBSimulator_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/base/INode.hpp"
#include "ITVCard.hpp"

namespace NMM
{

  class IDVBSimulator : virtual public ITVCard { 
  public:
    IDVBSimulator() {  setTypeInfo(TypeInfo(IDVBSimulator::IDVBSimulator_type, "NMM")); };

    IDVBSimulator(NMMObject& parent) : ITVCard(parent) {  setTypeInfo(TypeInfo(IDVBSimulator::IDVBSimulator_type, "NMM")); setEventReceiver(parent); };

    virtual ~IDVBSimulator() {};

    static const char* IDVBSimulator_type;

    virtual  string getInterfaceType() const { return IDVBSimulator_type; }

    Interface* copy() const { return new IDVBSimulator(*this); }
    static const char* setWorkingDirectory_event;

    virtual void setWorkingDirectory(const string& dir) /* limited(INode::CONSTRUCTED) */
      throw(const Exception&, const IllegalStateException&);


  };

  typedef auto_ptr<IDVBSimulator> IDVBSimulator_var;




}

#endif
