/* NMM - Network-Integrated Multimedia Environment
 *
 * Copyright (C) 2002 Network-Multimedia Workgroup, 
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Network-Multimedia Workgroup,
 *                    http://www.networkmultimedia.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_SCALER_H_
#define _NMM_SCALER_H_


struct ImagePlane {
  int offset;
  int x_pixels;
  int y_pixels;
  int x_pitch;
  int y_pitch;
};


extern "C" {
  
  //void scaleImagePlane(char* out_data, int out_width, int out_height, int out_pitch,
  //		     const char* in_data, int in_pitch,
  //		     int in_delta_x, int in_delta_y);
  
  void scaleImageRow(char* out_data, int out_width, const char* in_data, int in_pitch, int in_delta_x, int iny_frac);
  
  void scaleImageRowFiltering(char* out_data, int out_width, const char* in_data, int in_pitch, int in_delta_x, int iny_frac);

}

#endif //_NMM_SCALER_H_

