/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_KFIRREADNODE_HPP_
#define _NMM_KFIRREADNODE_HPP_ _NMM_KFIRREADNODE_HPP_

#include "nmm/base/GenericSourceNode.hpp"

#define MAX_CHARS        256
#define BUFFER_SIZE			 262144

namespace NMM {
  
  class KfirReadNode : public GenericSourceNode
  {
  private:
    string devicename;
  protected:
    int  fd; //file-descriptor
    
  public:
    KfirReadNode(const char *name = "KfirReadNode",
		 StreamQueue::Mode = StreamQueue::MODE_SUSPEND,
		 int = StreamQueue::DEFAULT_SIZE);
    virtual ~KfirReadNode();
    void setInputDevice(const char *devicename_);
    Result doInit();
    virtual Buffer* processBuffer(Buffer *);
  };
  
}
#endif
