/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#include "ProtocolReader.hpp"
#include "nmm/base/Node.hpp"

namespace NMM {

  ProtocolReader::ProtocolReader(Node* _parent, const string _name)
    : name(_name), 
    parent(_parent),
    is_eof(false) {
    PROTO_DEBUG_STREAM("PR Constructor!" << endl);
  }; /* ProtocolReader */

  ProtocolReader::~ProtocolReader() {

  }; /* ~ProtocolReader */

  bool ProtocolReader::parseURL(const string) {
    return false;
  }; /* parseURL */

  bool ProtocolReader::init() {
    return false;
  }; /* init */

  bool ProtocolReader::setURL(const string _url) {
    PROTO_DEBUG_STREAM("In setURL!" << endl);
    return (parseURL(_url) && init());
  }; /* setURL */

  bool ProtocolReader::eof() {
    return is_eof;
  }; /* init */

  int ProtocolReader::readData(char*, size_t) {
    return false;
  }; /* readData */

}
