/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:  David Maass (dama@graphics.cs.uni-sb.de)       
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _NMM_OSDELEMENTBASE_HPP
#define _NMM_OSDELEMENTBASE_HPP

#include "nmm/NMMTypes.hpp"

namespace NMM {
  /**
   * OSD Element Base
   */
  class OSDElementBase{
  public:
    virtual Result selectLeft()  = 0;
    virtual Result selectRight() = 0;
    virtual Result selectUp()    = 0;
    virtual Result selectDown()  = 0;

    virtual void setHeader(string) {};
    virtual void setDimension(uint, uint) {};
    virtual void setPosition(uint,uint) {};
    virtual void setColors(uint,uint,uint,uint,uint) {};
    virtual void deSelectWindow() {};
    virtual void selectWindow(unsigned int) {};

    virtual void update()        = 0;
    virtual void show()          = 0;
    virtual void hide()          = 0;
    virtual bool isHidden()      = 0;

    virtual unsigned int getSelectedLine()  {return 0;}
    virtual void selectLine(const unsigned int& ) {}
  };
}
#endif
