/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_MESSAGEUNIT_HPP_
#define _NMM_MESSAGEUNIT_HPP_ _NMM_MESSAGEUNIT_HPP_

#include "OSDElement.hpp"

#include "nmm/interfaces/video/osd/manager/ITextView.hpp"
#include "nmm/interfaces/video/osd/manager/IRadioButtons.hpp"
#include "nmm/interfaces/video/osd/manager/IBorderDecorator.hpp"
#include "nmm/interfaces/video/osd/manager/IPlaneDecorator.hpp"
#include "nmm/interfaces/video/osd/manager/IScrollDecorator.hpp"
#include "nmm/interfaces/video/osd/manager/IHeaderDecorator.hpp"

namespace NMM {
  class MessageUnit : public OSDElement {
  public:
    
    MessageUnit( IOSDManager* manager, IWidgetFactory* factory, string font );
    ~MessageUnit();
    
    Result selectLeft();
    Result selectRight();
    string messageID();
    
    Result print( string headerstr, string text, string label1, string label2="", string label3="", unsigned int sel=0 );
    
  protected:
    void deleteWidgets();
    
    string font;
    
    ITextView_var        text;
    IPlaneDecorator_var  plane;
    IBorderDecorator_var border;
    IHeaderDecorator_var header;
    IWidgetComposite_var composite;
    IRadioButtons_var    radiobuttons;
  };
  
}

#endif //_NMM_MESSAGEUNIT_HPP_
