/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_DECOHEADER_HPP_
#define _NMM_DECOHEADER_HPP_ _NMM_DECOHEADER_HPP_

#include "decorators.hpp"
#include "../widgets/textdraw.hpp"

#include "nmm/interfaces/video/osd/manager/IHeaderDecoratorImpl.hpp"

namespace NMM {
  /*****************************************************************************************/
  /* HeaderDecorator									   */
  /*****************************************************************************************/
  class HeaderDecorator : virtual public Decorator,
                          virtual public IHeaderDecoratorImpl {
  protected:
    /** font that is used to draw the text */
    BitmapFont*    font;
    
    /** class that contains some functions to draw text */
    TextDraw       textdraw;
    
    /** header text */
    string         headerstr;
    
    
    /**
     * Draws a header above a workspace
     * @param ws pointer to the workspace
     */
    void drawHeader( workspace_t* ws );
    
  public:
    HeaderDecorator();
    
    /** IHeaderDecorator interface. */
    virtual void setFont( const string& value );
    virtual void setText( const string& value );
    
    /** Draws Widget with Header. */
    virtual void draw( workspace_t* ws );
    
  }; // HeaderDecorator
} // NMM

#endif //_NMM_DECOHEADER_HPP_
