/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_TEXTDRAW_HPP_
#define _NMM_TEXTDRAW_HPP_ _NMM_TEXTDRAW_HPP_

#include "nmm/utils/font/font.hpp"

namespace NMM {

  class TextDraw {
    public:
    /**
    * draw text within a given rectangle
    * \param text text that should be drawn
    * \param font font that should be used to draw the text
    * \param frame destination where the text should be drawn to
    * \param xstart x position where the painting should begin
    * \param xstart y position where the painting should begin
    * \param xend x end position where the painting should stop
    * \param yend y end position where the painting should stop
    * \param stride number of pixel to get into the next line
    */
    bool draw( const char* text, BitmapFont* font, unsigned int* frame, unsigned int stride,
               unsigned int xstart, unsigned int ystart,
               unsigned int xend, unsigned int yend );


  }; // TextDraw

}
#endif //_NMM_TEXTDRAW_HPP_

